#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_TurretSkillCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_TurretSkillCFG> Fish_TurretSkillCFG::msSingleton(nullptr);

int Fish_TurretSkillCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_TurretSkillCFGData* Fish_TurretSkillCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_TurretSkillCFGData>& Fish_TurretSkillCFG::GetMapData()
{
	return mMapData;
}

void Fish_TurretSkillCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_TurretSkillCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_TurretSkillCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mSkillId = element->IntAttribute("SkillId");
		data.mSkillDesc = element->Attribute("SkillDesc");
		{
			const char* Value = element->Attribute("Value");
			std::vector<std::string> vecValue;
			boost::split(vecValue, Value, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecValue.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecValue[i].c_str(), &temp))
				{
					data.mValue.push_back(temp);
				}
			}
		}
		data.mValueShu = element->IntAttribute("ValueShu");
		data.mSkillResources = element->Attribute("SkillResources");
		data.mAddValue = element->IntAttribute("AddValue");
		data.mTopValue = element->IntAttribute("TopValue");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_TurretSkillCFG::Load()
{
	Load("../Config/Fish_TurretSkillCFG.xml");
}

Fish_TurretSkillCFG* Fish_TurretSkillCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_TurretSkillCFG());
	}
	return msSingleton.get();
}
